package com.is2t.example;

import com.is2t.microej.frontpanel.display.GenericDisplayExtension;

public class MyDisplayExtension extends GenericDisplayExtension {

	/**
	 * rgb color: xxxx xxxx RRRR Rxxx GGGG GGxx BBBB Bxxx
	 * lcd color: RRRR RGGG GGGB BBBB
	 * we keep 5 msbits R & B and 6 mbmits for G
	 */
	@Override
	public int convertRGBColorToDisplayColor(int rgbColor) {
		/*
		 * The RGB value encodes:
		 * 0xf80000 = 1111 1000 0000 0000 0000 0000 - the RED part
		 * 0x00fc00 = 1111 1100 0000 0000 - the GREEN part
		 * 0xf8 = 1111 1000 - the BLUE part
		 */
		return ((rgbColor & 0xf80000) >> 8) | ((rgbColor & 0x00fc00) >> 5) | ((rgbColor & 0xf8) >> 3);
	}

	/**
	 * lcd color: RRRR RGGG GGGB BBBB
	 * rgb color: 0000 0000 RRRR R000 GGGG GG00 BBBB B000
	 * we keep 5 msbits R & B and 6 mbmits for G
	 */
	@Override
	public int convertDisplayColorToRGBColor(int color) {
		/*
		 * The display pixel value encodes:
		 * 0xf800 = 1111 1000 0000 0000 - the RED part
		 * 0x07e0 = 111 1110 0000 - the GREEN part
		 * 0x001f = 1 1111 - the BLUE part
		 */
		return ((color & 0xf800) << 8) | ((color & 0x07e0) << 5) | ((color & 0x001f) << 3);
	}

	@Override
	public boolean isColor() {
		return true;
	}

}
