package com.is2t.example;

import ej.microui.EventGenerator;
import ej.microui.io.Buttons;
import ej.microui.io.Display;
import ej.microui.io.Viewable;

public class DisplayAndInputsApp {

	public static void main(String[] args) {
		EventGenerator[] eventGenerators = EventGenerator.get(Buttons.class);
		if (eventGenerators.length == 0) {
			System.out.println("MicroUI is misconfigured - less than one Button generators");
			return;
		}
		Display display = Display.getDefaultDisplay();
		if (display == null) {
			System.out.println("MicroUI is misconfigured - no display");
			return;
		}

		MyModel model = new MyModel();
		
		MyView view = new MyView(0, 0, display.getWidth(), display.getHeight());
		view.setModel(model);
		
		MyEventListener controller = new MyEventListener(model);
		
		Viewable viewable = new Viewable(display);
		viewable.setComponentView(view);
		viewable.setEventListener(controller);
		viewable.show();
	}

}
